\section{Debugging Techniques Comparison}
\label{sec:Debugging_Techniques_Comparison}

In \Cref{subsec:Debugging_Mobile_Embedded_Devices}, we have described that embedded devices can be differentiated by the used communication medium.
The use of either a wired or wireless transmission media can be seen as a major point of differentiation.
For mobile embedded devices, the availability of a communication medium and the characteristics of the energy supply, suggest an additional differentiation between a continuous or aperiodic data transmission. 
In this section, we therefore derive a matrix of debugging techniques from the constraints given in \Cref{subsec:Constraints}.

\begin{figure}
    \vspace{-0.3cm}
    \centering
    \includegraphics[width=0.75\linewidth]{images/overview.png}
    \caption{Debugging Techniques: 1) Aperiodic Wired Transmission 2) Aperiodic Wireless Transmission 3) Continuous Wired Transmission 4) Continuous Wireless Transmission.}
    \vspace{-0.2cm}
  \label{figure:Debugging_Techniques}
\end{figure}

We subdivide the available debugging techniques for embedded devices into four categories along the axes of communication media, as well as their availability as shown in \Cref{figure:Debugging_Techniques}.
For each of the four categories, debugging techniques are introduced and assessed qualitatively.
A case study evaluating these four techniques on the example of self-driving slot cars will be presented in the subsequent \Cref{sec:Case_Study}.

\subsubsection{Aperiodic Wired Transmission}
In this case, stable wired transmission is available only during limited periods of time or in certain operating conditions.
It requires saving debugging logs until the wired connection is available.
This results in an increased memory and storage consumption.
Additionally, increased computational resources are required whenever the connection becomes available.

The low computational overhead during logging makes it especially applicable for optimization purposes.
The typically low setup and implementation efforts needed for implementing a wired transmission make it applicable for early stages of development as well.

An example could be a solar-powered environmental sensor where the energy supply is insufficient for wireless transmission but where data is being regularly collected on-site.

\subsubsection{Aperiodic Wireless Transmission}
When wireless transmission media are available, however not continuously and stable, then the use of an aperiodic wireless transmission can be applicable.
Again, this requires saving debugging logs until wireless communication is established.
Therefore, more memory and storage are required, as well as additional computational overhead when establishing a wireless connection and transmitting.
Especially the setup and teardown of the wireless communication stack (e.g., WiFi/Bluetooth) can incur a significant overhead~\cite{DBLP:conf/www/QianWGHGMSS12}.

Especially in a development environment, an aperiodic wireless transmission can be stably ensured which makes this technique usable for remote software development.
Likewise, due to the low overhead when not transmitting, this technique can be suitable for optimization as well.
The ease of use and widespread adoption of wireless technologies makes this technique usable also in production for transmitting failure reports alike.
%, as long as the transmission environment can be reached without straining the use case of the device.

In the real world, wearable devices (e.g., health trackers, smartwatches) fit in this category, as they often require proximity to the home network or a smartphone for Internet access.

\subsubsection{Continuous Wired Transmission}
For this technique, continuous access to a wired connection must be ensured.
In comparison to wireless equivalents, lower overhead in computation and data storage can be expected.
% Generally, this case is characterized by low, constant overhead, as minimal data needs to be saved and wired transmission stacks are typically less resource intensive than wireless equivalents.
Because the physical setup of a separate infrastructure solely for the transfer of debugging logs is expensive and often infeasible, existing infrastructures can be reused (e.g., power lines).
%Therefore, data rates are often limited and might suffer from outages.

The overall low overhead makes this technique satisfactory for monitoring and operational status.
These require continuous but small data transfers.
Additionally, the low overhead makes it usable for optimization purposes as long as the limited data rates are sufficient.

Whilst this case is theoretically possible, it is also the most unlikely to occur in practice, as it would require continuous access to a mobile device via a wired transmission medium.
However, one such case could be the transmission of data using the contact wire of a railway track.

\subsubsection{Continuous Wireless Transmission}
Wireless transmission has the advantage of easier availability for devices on the move.
On the flip side, the continuous operation of the wireless stack is compute- and thus energy-intensive.
However, data does not have to be stored for extended periods on the device.

The continuous connection is especially advantageous when transmitting monitoring and operational status data.
If a stable wireless transmission can be ensured, this technique is applicable for development purposes.
Due to its ease of access, it encourages faster development cycle times that improve the quality of development~\cite{DBLP:journals/isj/BaskervilleP04}.
Furthermore, a failure in production can more easily be reported, as wireless networks are more and more part of production environments.
% lp: verstehe ich nicht: and does not impact the usability of the device.

This makes it usable, e.g., for smartphones that provide continuous access to wireless (including cellular) networks.